package com.kexun.controller;

//import ch.qos.logback.core.rolling.helper.FileStoreUtil;
//import ch.qos.logback.core.util.FileUtil;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.kexun.common.utils.Result;
import com.kexun.entity.*;
import com.kexun.model.ro.FiledTemplateCreateRO;
import com.kexun.model.ro.FiledTemplateRO;
import com.kexun.model.ro.FiledTemplateUpdateRO;
import com.kexun.service.FieldTemplateService;
import lombok.extern.java.Log;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.*;

import java.util.List;
//字段模版

@RestController
@RequestMapping("/admin/fieldtemplate")
@Log
public class FieldTemplateController {

    @Autowired
    private FieldTemplateService fieldTemplateService;


    /**
     * 获取字段模版信息
     *
     * @return
     */
    @GetMapping("fieldTemplateList")
    public Result fieldTemplateList() {
        JSONObject resJson = new JSONObject();
        List<FieldTemplateEntity> list = fieldTemplateService.list();
        resJson.put("field_template_list", list);
        return Result.success("ok", resJson);
    }

    /**
     * 获取字段模板列表分页信息
     *
     * @param filedTemplateRO
     * @return
     */
    @GetMapping("list")
    public Result list(@RequestBody FiledTemplateRO filedTemplateRO) {
        Result result = new Result();
        IPage<FieldTemplateEntity> fieldTemplateEntityIPage = fieldTemplateService.listPage(filedTemplateRO);
        result.setData(fieldTemplateEntityIPage);
        return result;
    }

    /**
     * 字段模板详情
     *
     * @param id
     * @return
     */
    @GetMapping("detail")
    public Result detail(@RequestParam Long id) {
        Result result = new Result();
        if (StringUtils.isEmpty(id)) {
            return Result.error("-1", "字段定义的ID不能为空");
        }
        FieldTemplateEntity fieldTemplateEntity = fieldTemplateService.getById(id);
        result.setData(fieldTemplateEntity);
        return result;
    }

    /**
     * 保存
     *
     * @param filedTemplateCreateRO
     * @return
     */
    @PostMapping("save")
    public Result save(@RequestBody FiledTemplateCreateRO filedTemplateCreateRO) {
        Result result = new Result();
        fieldTemplateService.save(filedTemplateCreateRO);
        return result;
    }

    /**
     * 修改
     *
     * @param filedTemplateUpdateRO
     * @return
     */
    @PostMapping("update")
    public Result update(@RequestBody FiledTemplateUpdateRO filedTemplateUpdateRO) {
        Result result = new Result();
        if (null != filedTemplateUpdateRO.getId()) {



        } else {
           return Result.error(-1,"id不存在");
        }
        return result;
    }


}
