package com.kexun.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.kexun.entity.BusInfoModifyHis;
import com.kexun.entity.FieldDefineEntity;
import com.kexun.hander.PageBean;
import com.kexun.mapper.BusInfoModifyHisMapper;
import com.kexun.mapper.FieldDefineMapper;
import com.kexun.model.ro.FiledRO;
import com.kexun.model.ro.FiledUpdateRO;
import com.kexun.service.FieldDefineService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.kexun.utils.PageUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import java.util.Date;
import java.util.List;

/**
 * <p>
 * 字段定义表 服务实现类
 * </p>
 *
 * @author lgs
 * @since 2023-06-21
 */
@Service
public class FieldDefineServiceImpl extends ServiceImpl<FieldDefineMapper, FieldDefineEntity> implements FieldDefineService {


    @Autowired
    private FieldDefineMapper fieldDefineMapper;

    /**
     * 分页查询字段定义
     *
     * @param filedRO
     * @return
     */
    @Override
    public IPage<FieldDefineEntity> listPage(FiledRO filedRO) {
        PageBean<FieldDefineEntity> page = new PageBean<>(PageUtils.getPageNo(filedRO.getPageNo()), PageUtils.getPageSize(filedRO.getPageSize()));
        QueryWrapper queryWrapper = new QueryWrapper();
        if (!StringUtils.isEmpty(filedRO.getCategory())) {
            queryWrapper.eq("category", filedRO.getCategory());
        }
        if (!StringUtils.isEmpty(filedRO.getFieldNo())) {
            queryWrapper.eq("field_no", filedRO.getFieldNo());
        }
        if (!StringUtils.isEmpty(filedRO.getNameZh())) {
            queryWrapper.eq("name_zh", filedRO.getNameZh());
        }
        IPage<FieldDefineEntity> pageList = fieldDefineMapper.selectPage(page, queryWrapper);
        return pageList;
    }

    /**
     * 保存或者修改字段定义
     * @param filedUpdateRO
     */
    @Override
    public void saveOrUpdate(FiledUpdateRO filedUpdateRO) {
        Long id = filedUpdateRO.getId();
        FieldDefineEntity defineEntity = getById(id);
        FieldDefineEntity fieldDefineEntity = new FieldDefineEntity();
        BeanUtils.copyProperties(filedUpdateRO,fieldDefineEntity);
        if (null != defineEntity) {
            updateById(fieldDefineEntity);
        }else {
            save(fieldDefineEntity);
        }
    }

    /**
     * 修改状态
     * @param id 主键
     * @param status 状态
     */
    @Override
    public void updateOnOff(Long id,String status){
        fieldDefineMapper.updateStatus(id,status);
    }
}
