package com.kexun.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.kexun.entity.*;
import com.kexun.hander.PageBean;
import com.kexun.mapper.CooperatorMapper;
import com.kexun.mapper.FieldTemplateMapper;
import com.kexun.model.ro.*;
import com.kexun.service.CooperatorService;
import com.kexun.service.FieldTemplateRefService;
import com.kexun.service.FieldTemplateService;
import com.kexun.utils.PageUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;


import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;

/**
 *
 */
@Service
public class FieldTemplateServiceImpl extends ServiceImpl<FieldTemplateMapper, FieldTemplateEntity> implements FieldTemplateService {

    @Autowired
    FieldTemplateMapper fieldTemplateMapper;
    @Autowired
    FieldTemplateRefService fieldTemplateRefService;

    @Override
    public IPage<FieldTemplateEntity> listPage(FiledTemplateRO filedTemplateRO) {
        PageBean<FieldTemplateEntity> page = new PageBean<>(PageUtils.getPageNo(filedTemplateRO.getPageNo()), PageUtils.getPageSize(filedTemplateRO.getPageSize()));
        QueryWrapper queryWrapper = new QueryWrapper();
        //字段模板编号
        if (!StringUtils.isEmpty(filedTemplateRO.getTemplateNo())) {
            queryWrapper.eq("templateNo", filedTemplateRO.getTemplateNo());
        }
        //字段模板名称
        if (!StringUtils.isEmpty(filedTemplateRO.getTemplateName())) {
            queryWrapper.eq("templateName", filedTemplateRO.getTemplateName());
        }
        IPage<FieldTemplateEntity> pageList = fieldTemplateMapper.selectPage(page, queryWrapper);
        return pageList;
    }

    /**
     * 保存模板字段
     *
     * @param filedTemplateCreateRO
     */
    @Override
    public void save(FiledTemplateCreateRO filedTemplateCreateRO) {
        if (null != filedTemplateCreateRO) {
            FieldTemplateEntity fieldTemplateEntity = new FieldTemplateEntity();
            BeanUtils.copyProperties(filedTemplateCreateRO, fieldTemplateEntity);
            fieldTemplateMapper.insert(fieldTemplateEntity);
            Long id = fieldTemplateEntity.getId();
            //模板字段关系表
            List<FiledUpdateRO> filedList = filedTemplateCreateRO.getFiledList();

            List<FieldTemplateRefEntity> fieldTemplateRefList = new ArrayList<>();
            for (FiledUpdateRO filedUpdateRO : filedList) {
                FieldTemplateRefEntity fieldTemplateRefEntity = new FieldTemplateRefEntity();
                fieldTemplateRefEntity.setFieldTemplateId(id);
                fieldTemplateRefEntity.setTemplateNo(filedTemplateCreateRO.getTemplateNo());
                fieldTemplateRefEntity.setFieldDefineId(filedUpdateRO.getId());
                fieldTemplateRefEntity.setFieldNo(filedUpdateRO.getFieldNo());
                fieldTemplateRefEntity.setName(filedUpdateRO.getName());
                fieldTemplateRefEntity.setType(filedUpdateRO.getType());
                fieldTemplateRefList.add(fieldTemplateRefEntity);
            }
            fieldTemplateRefService.saveBatch(fieldTemplateRefList);
        }
    }

    /**
     * 修改模板
     * @param filedTemplateUpdateRO
     */
    @Override
    public void update(FiledTemplateUpdateRO filedTemplateUpdateRO) {
        Long id = filedTemplateUpdateRO.getId();
        FieldTemplateEntity fieldTemplateEntity = fieldTemplateMapper.selectById(id);



    }
}




